
// ----------------------------------------------------------------------------
// check if it's one of the (already) known compilers
// ----------------------------------------------------------------------------

{$IFDEF VER130} {$DEFINE D5GE} {$ENDIF} // D5
{$IFDEF VER140} {$DEFINE D5GE} {$DEFINE D6GE} {$ENDIF} // D6
{$IFDEF VER150} {$DEFINE D5GE} {$DEFINE D6GE} {$DEFINE D7GE} {$ENDIF} // D7

{$IFNDEF D5GE}
   {$MESSAGE FATAL 'Unsupported compiler version - see file Compiler.inc!'}
{$ENDIF}


// ----------------------------------------------------------------------------
// compiler directives
// ----------------------------------------------------------------------------

{$ALIGN ON}           // suggested
{$BOOLEVAL OFF}       // mandatory
{$LONGSTRINGS ON}     // mandatory
{$IOCHECKS ON}        // mandatory
{$EXTENDEDSYNTAX ON}  // mandatory
{$WRITEABLECONST OFF} // suggested
{$DEBUGINFO ON}       // suggested
{$LOCALSYMBOLS ON}    // suggested
{$REFERENCEINFO ON}   // suggested


// ----------------------------------------------------------------------------
// compiler specific settings
// ----------------------------------------------------------------------------

{$UNDEF H_NEED_VARIANTS} // Variant-functions located in separate Variants-unit

{$IFDEF D6GE}
   {$DEFINE H_NEED_VARIANTS}
   {$WARN UNIT_PLATFORM OFF}   // turn off platform-warnings
   {$WARN SYMBOL_PLATFORM OFF} // turn off platform-warnings
{$ENDIF}

{$IFDEF D7GE}
   {$DEFINE H_NEED_VARIANTS}
   {$WARN UNIT_PLATFORM OFF}   // turn off platform-warnings
   {$WARN SYMBOL_PLATFORM OFF} // turn off platform-warnings
{$ENDIF}

// ----------------------------------------------------------------------------
// enable/disable Hamster extensions
// ----------------------------------------------------------------------------

// use "HTML Help Kit for Delphi" (www.helpware.net) for HtmlHelp support
{$DEFINE USE_HTMLHELPKIT}

// use "THtmlLite Component" (www.pbear.com) for reports
{$DEFINE USE_THTMLLITE}

// ----------------------------------------------------------------------------

