unit GOutils;

interface

uses Global, cArticle, IniFiles, Classes;

procedure UserAgentCompose(var Art: TArticle; GNews: Boolean);
procedure QPTranslation(var Art: TArticle);
procedure AntiPub(var Art: TArticle; const Newsgroup: String);
procedure Signature(var Art: TArticle);
procedure Nettoyeur(var Art: TArticle);
procedure ContLines(var Art: TArticle);
Function Rectif(s: String):String;
Function MailFormat(stdFrom: string): string;
Function Conversion:Boolean;
Function Lettre(tt: string):Boolean;
Function Chiffre(tt: string):Boolean;
procedure FixOutlookBadRe(var Art: TArticle);

implementation

uses uEncoding, SysUtils, cStdForm, cLogfile, uTools, cPCRE;

procedure UserAgentCompose(var Art: TArticle; GNews: Boolean);
var  g: Integer;
     s, s1, s2: String;
     Ok: Boolean;
begin
   s := '';
   s1 := Art['X-Mailer:'];
   if s1<>'' then Art.DeleteHeader('X-Mailer:');
   s2 := Art['X-Newsreader:'];
   if s2<>'' then Art.DeleteHeader('X-Newsreader:');
   s := Art['User-Agent:'];
   if s<>'' then Art.DeleteHeader('User-Agent:');
   if s='' then begin
     if GNews then begin
        if s2='' then s := s1
        else s := s2;
     end else begin
         if s1='' then s := s2
         else s := s1;
     end;
   end;
   s := trim(s);
   if s<>'' then Art.AddHeaderAfterSpecialHeaders('User-Agent:', s );

   Ok := false;
   if (Gnews) then begin
       if (Def_News_AddXHamster) then Ok:=true;
   end else begin
       if (Def_Mail_AddXHamster) then Ok:=true;
   end;

   if Ok then begin
     s := Art['User-Agent:'];
     if s<>'' then Art.DeleteHeader('User-Agent:');
     g := pos(' ' + OUR_VERINFO,s);
     if g>0 then s := copy(s,1,g-1);

     if (Gnews) then begin
         if (Def_News_ForceUA) then s := rectif(s);
     end else begin
         if (Def_Mail_ForceUA) then s := rectif(s);
     end;

     s1 := '(' + Def_Version1;
     if Def_Version<>'' then begin
        if Def_Version1<>'' then s1 := s1 + ';' + Def_Version
        else s1 := s1 + Def_Version;
     end;
     if s1='(' then s1 :=''
     else s1 := s1 + ')';
     s := s + ' ' + OUR_VERINFO;

     if (Gnews) then begin
         if (Def_News_ForceUA) then
             s := s + '/' + GetMyBuildInfo + s1
         else s := s + ' ' + GetMyBuildInfo + ' ' + s1;
     end else begin
         if (Def_Mail_ForceUA) then
             s := s + '/' + GetMyBuildInfo + s1
         else s := s + ' ' + GetMyBuildInfo + ' ' + s1;
     end;
     
     Art.AddHeaderAfterSpecialHeaders('User-Agent:', s );
   end;
end;

procedure QPTranslation(var Art: TArticle);
var  i, g: Integer;
     DestEncode: String;
     Buf1, Buf2, s, s1: String;
     g3: Byte;
begin
   DestEncode  := Art['Content-Transfer-Encoding:'];

   if (DestEncode='quoted-printable') then begin
      g := Pos( #13#10#13#10, Art.Text);
      if g > 0 then begin
         Art.DeleteHeader('Content-Transfer-Encoding:');
         Art.AddHeader('Content-Transfer-Encoding:', '8bit');
         Art.AddHeader('X-Mime-Autoconverted:', 'from quoted-printable to 8bit by ' + OUR_VERINFO);
         i := g;
         s := copy(Art.Text, 1, i+3);
         Buf1 := copy(Art.text, i+4, length(Art.Text));
         i := pos( '=', Buf1);
         while i > 0 do
            begin
            s := s + copy(Buf1, 1, i-1);
            Buf2 := copy(Buf1, i+1, 1);
            g := (pos(Buf2, Def_IsHexa) - 1) * 16;
            Buf2 := copy(Buf1, i+2, 1);
            g := g + pos(Buf2, Def_IsHexa) - 1;
            Buf2 := copy(Buf1, i+1, 1) + Buf2;
            if (g > 0) and (g < 256) then begin
               g3 := g;
               s := s + chr(g3)
            end
         else
            if (Buf2<>#13#10) then begin
               s := s + '=' + Buf2;
            end ;
         i := i + 2;
         System.Delete(Buf1, 1, i);
         i := pos( '=', Buf1);
         end;
         s := s + Buf1;
         Art.Text := s;
         Log( LOGID_DETAIL, TrGlF(kLog, 'QP.converted',  //OZ - Translation
               'Article/email %s body converted from QP to 8bit',
               Art['Message-ID:']));
      end;
   end;
   if (DestEncode='base64') then begin                   //OZ - Base64 to 8bit
      i := Pos( #13#10#13#10, Art.Text);
      if i > 0 then begin
         Art.DeleteHeader('Content-Transfer-Encoding:');
         Art.AddHeader('Content-Transfer-Encoding:', '8bit');
         Art.AddHeader('X-Mime-Autoconverted:', 'from base64 to 8bit by ' + OUR_VERINFO);
         i := Pos( #13#10#13#10, Art.Text);
         s := copy(Art.Text, 1, i+3);
         s1 := copy(Art.text, i+4, length(Art.Text));
         Buf1 := s1;
         Buf2 := s1;
         i := Pos( #13#10, Buf2);
         g := i+1;
         while i > 0 do begin
            If (copy(Buf2, i-1, 1) = '=') then begin
               Buf1 := copy(s1, 1, g);
               Buf1 := DecodeB64( Buf1[1], length(Buf1) );
               s := s + Buf1;
               s1 := copy(Buf2, i+2, length(Buf2));
               g := 0;
            end;
            Buf2 := copy(Buf2, i+2, length(Buf2));
            i := Pos( #13#10, Buf2);
            g := g+i+1;
         end;
         If g > 0 then begin
            s1 := DecodeB64( s1[1], length(s1) );
            s := s + s1;
         end;
      end;
      Art.Text := s;
      Log( LOGID_DETAIL, TrGlF(kLog, 'Base64.converted',  //OZ - Translation
         'Article/email %s body converted from Base64 to 8bit',
         Art['Message-ID:']));
   end;
end;

procedure AntiPub(var Art: TArticle; const Newsgroup: String);
var
     GroupIni : TIniFile;
     g1, g2, ii: Integer;
     FileName, Adresse: String;
     Buf1, Buf2, s: String;
     Buf1IsRegex, Buf2IsRegex: Boolean;
begin
   Filename := PATH_GROUPS + Newsgroup + '\data' + EXT_CFG;
   GroupIni := TIniFile.Create(Filename);
   Try
      adresse := GroupIni.ReadString( 'Setup', 'Moderator', 'admin' + Def_FQDNMail );
   finally
      FreeAndNil(GroupIni);
   end;
   Filename := PATH_BASE + CFGFILE_PFILTER;
   GroupIni := TIniFile.Create(Filename);
   ii := - 1;
   Try
      repeat
         Buf1IsRegex := False;
         Buf2IsRegex := False;
         inc( ii );
         s := 'start' + trim(inttostr(ii));
         Buf1 := GroupIni.ReadString( adresse, s, '' );
         s := 'end' + trim(inttostr(ii));
         Buf2 := GroupIni.ReadString( adresse, s, '' );
         if ((Buf1<>'') and (Buf2<>'')) then begin
            if ( copy( Buf1, 1, 1 ) = '{' ) and ( copy( Buf1, length( Buf1 ), 1 ) = '}' ) then begin
               Buf1IsRegex := True;
               Buf1 := copy( Buf1, 2, length( Buf1 ) - 2 );
            end;
            if ( copy( Buf2, 1, 1 ) = '{' ) and ( copy( Buf2, length( Buf2 ), 1 ) = '}' ) then begin
               Buf2IsRegex := True;
               Buf2 := copy( Buf2, 2, length( Buf2 ) - 2 );
            end;
            if Buf1IsRegex then buf1 := RE_Extract( Art.FullBody, Buf1,
                                           PCRE_CASELESS or PCRE_MULTILINE or PCRE_DOTALL );
            g1 := pos(Lowercase( Buf1 ), Lowercase( Art.FullBody ) );
            if g1>0 then begin
               if Buf2='*' then g2 := length(Art.FullBody)
                  else begin
                     if Buf2IsRegex then Buf2 := RE_Extract( Art.FullBody, Buf2,
                                                    PCRE_CASELESS or PCRE_MULTILINE or PCRE_DOTALL );
                     g2 := pos(Lowercase( Buf2 ), Lowercase( Art.FullBody ) ) + length(Buf2) - 1;
                  end;
               if g2>g1 then begin
                  Art.FullBody := copy(Art.FullBody, 1, g1-1) + copy(Art.FullBody, g2+1, length(Art.FullBody));
                  Log( LOGID_DETAIL, TrGl(kLog, 'Antipub.filtered',
                    'Advert striped from an article for newsgroup') + ' ' + Newsgroup );
               end;
            end;
         end else break;  // Plus d'entre start
      until false;
   finally
      FreeAndNil(GroupIni);
   end;
end;

procedure Signature(var Art: TArticle);
var  s, t: String;
begin
   s := #13#10 + '--' + #13#10;
   t := #13#10 + '-- ' + #13#10;
   if Pos( s, Art.FullBody ) <> 0 then
      Log( LOGID_DETAIL, TrGl(kLog, 'Signature.corrected',  //OZ - Translation
         'Bad signature separator corrected') );
   Art.FullBody := StringReplace( Art.FullBody, s, t, [rfReplaceAll] );
end;

procedure Nettoyeur(var Art: TArticle);
begin
   if Art.FullBody <> '' then repeat
      if ( Art.FullBody[length( Art.FullBody )] in [ #9, #10, #13, ' ' ] )
         then Art.FullBody := Copy( Art.FullBody, 1, length( Art.FullBody ) - 1 )
         else break;
   until Art.FullBody = '';
   Art.FullBody := Art.FullBody + #13#10;
end;

procedure ContLines(var Art: TArticle);
var  SL: TStringList;
     s1: string;
begin
   SL := TStringList.Create;
   try
      s1 := Art['Lines:'];
      if s1<>'' then Art.DeleteHeader('Lines:');
      SL.Text := Art.FullBody;
      Art.AddHeader('Lines:', Trim(IntToStr(SL.Count)));
   finally
      SL.Free;
   end;
end;

Function Conversion:Boolean;
Var
     Nom : TSearchRec;
     Gtype, GAdresse, GMod : string;
     GroupIni : TIniFile;
     FileName: String;
     Ok: Boolean;
begin
     Ok := False;
     FindFirst(PATH_GROUPS + '*.*', faAnyFile, Nom);
     repeat
     if (Nom.Attr and faDirectory)>0 then begin
        if (Nom.Name[1] <> '.') and (Nom.Name<>'News.Err') and (Nom.Name<>'News.Out') then begin
           Filename := PATH_GROUPS + Nom.Name +'\data'+ EXT_CFG;
           GroupIni := TIniFile.Create(Filename);
           Try
              Ok := True;
              GType := GroupIni.ReadString('Setup','type','');
              GAdresse := GroupIni.ReadString('Setup','adresse','');
              GMod := GroupIni.ReadString('Setup','Moderator','');
              if (GType='l') then begin
                 GroupIni.WriteString('Setup','type','g');
                 Log( LOGID_INFO, Nom.Name + ' ... Type');
              end;
              if (GAdresse<>'') then begin
                 GroupIni.WriteString('Setup','adresse','');
                 If GMod = '' then begin
                    GroupIni.WriteString('Setup','Moderator',GAdresse);
                    Log( LOGID_INFO, Nom.Name + ' ... Moderator');
                 end;
              end;
           finally
              FreeAndNil(GroupIni);
           end;
        end;
     end;
     until (FindNext(Nom)<>0);
     FindClose(Nom);
     Result := Ok;
end;

Function Rectif(s: String):String;
var
     ii, parh : integer;
     parb : boolean;
     usag : string;
     s2, s3: String;
begin
     s3 := '$' + trim(s) + '$';
     s2 := '';
     usag := '';
     parh := 0;
     parb := false;
     for ii := 2 to length(s3) do begin
        usag := s3[ii];
        case s3[ii] of
        '(' : inc(parh);
        ')' : dec(parh);
        '/' : if parb then usag := '-';
        ' ' : if parh=0 then begin
                 if lettre(s3[ii-1]) and lettre(s3[ii+1])then begin
                    usag := '-';
                    parb := false;
                 end;
                 if lettre(s3[ii-1]) and chiffre(s3[ii+1]) then begin
                    usag := '/';
                    parb := true;
                 end;
                 if chiffre(s3[ii-1]) and chiffre(s3[ii+1]) then usag := '.';
                 if (lettre(s3[ii-1]) or chiffre(s3[ii-1])) and (s3[ii+1]='(') then usag := '';
                 if s3[ii+1]=' ' then usag := '';
              end;
        end;
        if usag=' ' then parb := false;
        s2 := s2 + usag;
     end;
     result := copy(s2, 1, length(s2)-1);
end;

Function Lettre(tt: string):Boolean;
begin
   if pos(lowercase(tt),'$abcdefghijklmnopqrstuvwxyz')>0 then result := true
   else result := false;
end;

Function Chiffre(tt: string):Boolean;
begin
   if pos(tt,'0123456789')>0 then result := true
   else result := false;
end;

Function MailFormat(stdFrom: string): string;
var  s1 : string;
     i1,i2 : integer;
begin
     s1 := trim(stdFrom);
     if pos('<',s1)>0 then s1 := copy(s1, pos('<',s1)+1, length(s1));
     if pos('>',s1)>0 then s1 := copy(s1, 1, pos('>',s1)-1);
     i1 := pos('(',s1);
     i2 := pos(')',s1);
     if (i2>i1) and (i1>0) then begin
        s1:= copy(s1, 1, i1-1);
        s1:= s1 + copy(s1, i2+1, length(s1));
     end;
     Result := trim(s1);
end;

procedure FixOutlookBadRe(var Art: TArticle);
   Function BadReLoop(Subject: string): string;
   begin
      System.Delete( Subject, 1, pos( ':', Subject ) );
      Subject := Trim(Subject);
      if (( Pos( 're :', LowerCase( Subject ) ) = 1 )
      or ( Pos( 're:', LowerCase( Subject ) ) = 1 ) ) then
         Subject := BadReLoop(Subject);
      Result := Subject;
   end;
   
var
   Subject: String;
begin
   Subject := Art['Subject:'];
   if (( Pos( 're :', LowerCase( Subject ) ) = 1 )
   or ( Pos( 're:', LowerCase( Subject ) ) = 1 ) ) then begin
      Subject := BadReLoop(Subject);
      Art.DeleteHeader( 'Subject:' );
      Art.AddHeaderAfterSpecialHeaders( 'Subject:', 'Re: ' + Subject );
   end;
end;

end.


