unit GRechMid;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Global, cStdForm;

type
  TfmRechMid = class(THForm)
    Mid: TEdit;
    Recherche: TGroupBox;
    Ajouter: TButton;
    Supprimer: TButton;
    Fermer: TButton;
    ListMid: TListBox;
    Serveur: TListBox;
    procedure AjouterClick(Sender: TObject);
    procedure SupprimerClick(Sender: TObject);
    procedure Debut(Sender: TObject);
    procedure ServeurChange(Sender: TObject);
    
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
     fmRechMid: TfmRechMid;
     s, Nomfic, Nomserv: string;
     i, j: integer;
     ret, ForceSearch : boolean;

implementation

{$R *.DFM}

procedure TfmRechMid.AjouterClick(Sender: TObject);
begin
     s := fmRechMid.Mid.Text;
     if pos('@',s)>0 then begin
        s := trim(s);
        ForceSearch := False;
        if s[1]='!' then ForceSearch := True;
        i := pos('<',s);
        if i>0 then s := copy(s,i,length(s));
        i := pos('>',s);
        if i>0 then s := copy(s,1,i);
        if (s[1]<>'<') then s := '<' + s;
        while (s[length(s)]='.') do s := copy(s,1,length(s) - 1);
        if (s[length(s)]<>'>') then s := s + '>';
        if ForceSearch then s := '!' + s;
        fmRechMid.ListMid.Items.Add(s);
        fmRechMid.Mid.Text:='';
        fmRechMid.ListMid.Items.SaveToFile(Nomfic);
     end;
end;

procedure TfmRechMid.SupprimerClick(Sender: TObject);
begin
     if fmRechMid.ListMid.Items.Count>0 then begin
        i := fmRechMid.ListMid.ItemIndex;
        if (i>-1) and (i<fmRechMid.ListMid.Items.Count)then begin
           s:= fmRechMid.ListMid.Items[i];
           if MessageDlg(Tr('Rechmid.Delete', 'Do you want delete this message-ID') + ' ' + s + ' ?',
              mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
              fmRechMid.ListMid.Items.Delete(i);
              if fmRechMid.ListMid.Items.Count=0 then
                 ret := DeleteFile(Nomfic)
              else fmRechMid.ListMid.Items.SaveToFile(Nomfic);
           end;
        end;
     end;
end;

procedure TfmRechMid.ServeurChange(Sender: TObject);
begin
     Nomserv := fmRechMid.Serveur.Items[fmRechMid.Serveur.ItemIndex];
     Nomfic := PATH_BASE + '\Server\' + Nomserv + '\Getmids.txt';
     if FileExists(Nomfic) then
        fmRechMid.ListMid.Items.LoadFromFile(Nomfic)
     else fmRechMid.ListMid.Items.Clear;
end;

procedure TfmRechMid.Debut(Sender: TObject);
var  i: integer;

begin
     PulseEvent(EventRechmid);
     fmRechMid.Serveur.Items.LoadFromFile(PATH_BASE + CFGFILE_SERVER_NNTP);
     For i := 0 to fmRechMid.Serveur.Items.Count - 1 do
     begin
          s := fmRechMid.Serveur.Items[I];
          j := pos(',',s) - 1;
          if J>0 then
             fmRechMid.Serveur.Items[I] := copy(s,1,j);
     end;
     fmRechMid.Serveur.ItemIndex := 0;
     Nomserv := fmRechMid.Serveur.Items[0];
     Nomfic := PATH_BASE + '\Server\' + Nomserv + '\Getmids.txt';
     if FileExists(Nomfic) then
        fmRechMid.ListMid.Items.LoadFromFile(Nomfic)
     else fmRechMid.ListMid.Items.Clear;
end;

end.
