unit WEditBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Global, Main, cStdForm;

type
  TfmEdit = class(THForm)
    EditMemo1: TMemo;
    EditBtnOk: TButton;
    EditBtnCancel: TButton;
    EditBtnSave: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;
  
var
  fmEdit: TfmEdit;
  Texte, Titre: string;
  Ligne, Ecriture: Integer;

  function EditBox(AText, ACaption: string;
                   AWrap, ARead: integer):string;

implementation

{$R *.DFM}

function EditBox(AText, ACaption: string;
                 AWrap, ARead: integer):string;
begin
     Texte := AText;
     Titre := ACaption;
     Ligne := AWrap;
     Ecriture := ARead;
     Application.CreateForm(TfmEdit, fmEdit);
     fmEdit.ShowModal;
     fmEdit.Release;
     Result := Texte;
     SetCurrentDirectory( PChar(PATH_BASE) );
end;

procedure TfmEdit.FormCreate(Sender: TObject);
begin
     fmedit.caption := Titre;
     EditMemo1.Text := Texte;
     if (Ligne=1) then begin
        EditMemo1.WordWrap := True;
        EditMemo1.ScrollBars := ssVertical;
     end else EditMemo1.ScrollBars := ssBoth;
     if (Ecriture=0) then begin
        EditBtnSave.Visible := False;
        EditBtnOk.Visible := True;
        EditBtnCancel.Visible := False;
        EditMemo1.Readonly := True;
     end else begin
        EditBtnSave.Visible := True;
        EditBtnOk.Visible := False;
        EditBtnCancel.Visible := True;
        EditMemo1.Readonly := False;
     end;
end;

procedure TfmEdit.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     if (Texte<>EditMemo1.Text) then Texte := EditMemo1.Text
     else Texte := '';
end;

end.


